init 10:
    python:
        import random
        random.seed()
        
        def battle_overlay():
            if currentbattle:
                ui.layer("transient")
                for i in uniquebattle:
                    def drawani(xmod):
                        if i.sprite.dir is _right:
                            xmod *= -1
                        
                        ui.at(Move((i.sprite.xpos,i.sprite.ypos),(i.sprite.xpos+xmod,i.sprite.ypos), 0.8))
                        i.sprite.xpos += xmod
                        ui.add(i.sprite.image())
                    
                    if i.sprite.move:
                        if i.sprite.move == 1:
                            drawani(-100)
                            i.sprite.move = 2
                        else:
                            drawani(100)
                            i.sprite.move = 0
                    else:
                        ui.at(Position(xpos=i.sprite.xpos, ypos=i.sprite.ypos, xanchor=0, yanchor=0))
                        ui.add(i.sprite.image())
                
                ui.window(xfill=False, xpos=1.0, xanchor=1.0, ypos=0.4, yminimum=0, yanchor=1.0, xmargin=20)
                ui.vbox()
                for i in currentbattle:
                    ui.hbox()
                    ui.text(i.name, minwidth=160)
                    if i.health < 10:
                        ui.text(str(i.health) + " HP")
                    else:
                        ui.text(str(i.health) + "HP")
                    ui.close()
                ui.close()
                
                ui.close()
        
        def select_one(friendly):
            ui.layer("overlay")
            ui.window(xfill=False, xpos=1.0, xanchor=1.0, ypos=0.65, yminimum=0, yanchor=1.0, xmargin=20)
            ui.vbox()
            if friendly:
                list = party
            else:
                list = currentbattle
            for j in list:
                if j.friendly is friendly:
                    ui.textbutton(j.name, clicked=ui.returns(j))
            ui.textbutton("Cancel", clicked=ui.returns(False))
            ui.close()
            ui.close()
            
            return ui.interact()
        
        def fill_names(string, user, target=None):
            if user in mira_class:
                string = string.replace("%x", "I")
                string = string.replace("%s", "")
            else:
                string = string.replace("%x", user.name)
                string = string.replace("%s", "s")
            
            if target:
                if target in mira_class:
                    string = string.replace("%y's", "my")
                    string = string.replace("%y", "me")
                else:
                    string = string.replace("%y", target.name)
            
            return string
        
        def itemsmagic(player, itemlist):
            item = None
            
            while not item:
                ui.layer("overlay")
                ui.window(xfill=False, xpos=1.0, xanchor=1.0, ypos=0.65, yminimum=0, yanchor=1.0, xmargin=20)
                ui.vbox()
                for j in itemlist:
                    if (j.inbattle and currentbattle) or (j.outofbattle and not currentbattle):
                        clicked = ui.returns(j.use(player, itemlist))
                    else:
                        clicked = None
                    
                    ui.textbutton(j.name, hovered=ui.returns(j.describe), clicked=clicked)
                ui.textbutton("Cancel", clicked=ui.returns(ui.returns(0)))
                ui.close()
                ui.close()
                
                item = ui.interact()()
                if item is 0:
                    return True
            return False
        
        def buysell():
            def buysellitems(buy):
                global partygold, allitems, partyitems
                item = 1
                
                while item:
                    ui.window(xfill=False, xpos=1.0, xanchor=1.0, ypos=0.65, yminimum=0, yanchor=1.0, xmargin=20)
                    ui.vbox()
                    ui.text(str(int(partygold/10)) + " gold pieces.")
                    if buy:
                        itemlist = allitems
                    else:
                        itemlist = partyitems
                    
                    for i in itemlist:
                        if i.cost <= partygold or not buy:
                            ui.button(clicked=ui.returns(i))
                        else:
                            ui.button(clicked=None)
                        ui.hbox()
                        ui.text(i.name, minwidth=300)
                        ui.text(str(int(i.cost/10)))
                        ui.close()
                    ui.textbutton("Back", clicked=ui.returns(0), minwidth=300)
                    ui.close()
                    
                    item = ui.interact()
                    if not item:
                        return
                    
                    if buy:
                        paryitems.items.append(item)
                        partygold -= item.cost
                    else:
                        partyitems.remove(item)
                        partygold += item.cost
            
            def buyspells(player):
                global partygold
                item = 1
                
                while item:
                    ui.window(xfill=False, xpos=1.0, xanchor=1.0, ypos=0.65, yminimum=0, yanchor=1.0, xmargin=20)
                    ui.vbox()
                    ui.text(str(int(partygold/10)) + " gold pieces.")
                    
                    for i in player.cancast:
                        if i.cost <= partygold:
                            ui.button(clicked=ui.returns(i))
                            ui.hbox()
                            ui.text(i.name, minwidth=300)
                            ui.text(str(int(i.cost/10)))
                            ui.close()
                        
                    ui.textbutton("Back", clicked=ui.returns(0), minwidth=300)
                    ui.close()
                    
                    item = ui.interact()
                    if not item:
                        return
                    
                    player.spells.append(item)
                    partygold -= item.cost
            
            while True:
                ui.window(xfill=False, xpos=1.0, xanchor=1.0, ypos=0.65, yminimum=0, yanchor=1.0, xmargin=20)
                ui.vbox()
                ui.text(str(int(partygold/10)) + " gold pieces.")
                ui.hbox()
                ui.textbutton("Buy items", clicked=ui.returns(0))
                ui.textbutton("Sell items", clicked=ui.returns(1))
                ui.close()
                ui.textbutton("Buy spell components", clicked=ui.returns(2))
                ui.textbutton("Quit", clicked=ui.returns(3))
                ui.close()
                choice = ui.interact()
                
                if choice is 3:
                    return
                elif choice is 0:
                    buysellitems(True)
                elif choice is 1:
                    buysellitems(False)
                elif choice is 2:
                    ui.window(xfill=False, xpos=1.0, xanchor=1.0, ypos=0.65, yminimum=0, yanchor=1.0, xmargin=20)
                    ui.vbox()
                    for i in party:
                        if i.cancast:
                            ui.textbutton(i.name, clicked=ui.returns(i), minwidth=160)
                    ui.textbutton("Back", clicked=ui.returns(0), minwidth=160)
                    ui.close()
                    
                    player = ui.interact()
                    if player:
                        buyspells(player)
        
        def battleorder():
            global currentbattle, uniquebattle
            newbattle = [ ]
            currentbattle = [ ]
            for i in range(25):
                newbattle.append(None)
            
            for i in uniquebattle:
                newbattle.insert(i.tempspeed, i)
                
                if i.tempspeed > 10:
                    newbattle.insert(i.tempspeed-10, i)
            
            for i in newbattle:
                if i:
                    currentbattle.insert(0,i)
        
        def battle(enemies, introduction, spoils=0, reward=0):
            def showmenu(player):
                choice = player.show_menu()
                
                if choice is 1:
                    target = select_one(False)
                    
                    if target:
                        player.attack(target)
                    else:
                        return True
                    return False
                elif choice is 2:
                    return itemsmagic(player, player.spells)
                elif choice is 3:
                    return itemsmagic(player, player.items)
                elif choice is 4:
                    player.ability(player)
            
            def victory():
                global currentbattle, uniquebattle, finalboss, partygold, partyitems
                
                if finalboss:
                    renpy.music.stop()
                    renpy.music.play("justdontgiveadamn.mp3")
                    x("We manage to kill the orc Captain through sheer force of will...")
                    
                    x("His warriors don't stand by idly. They charge at us, and we raise our weapons once more, prepared to fight...")
                    
                    x("...but we've already won.")
                
                if spoils:
                    renpy.music.stop()
                    renpy.music.play("justdontgiveadamn.mp3")
                    x("We beat the orcs!")
                    for j in range(spoils):
                        newitem = allitems[random.randrange(len(allitems))]
                        x("We found... " + newitem.name + ".")
                        partyitems.append(newitem)
                    x("We found... " + str(int(reward/10)) + " gold pieces.")
                    partygold += reward
                
                currentbattle = uniquebattle = [ ]
            
            global currentbattle, uniquebattle, _game_menu_screen, partygold, finalboss
            _game_menu_screen = None
            ymod = xmod = 0
            if len(enemies) > 1:
                for i in enemies:
                    if enemies.index(i) == 3:
                        ymod = 0
                        xmod += 50
                    
                    i.sprite.ypos = 160 + ymod
                    i.sprite.xpos = 200 - xmod
                    ymod += 50
            
            uniquebattle = enemies + party
            for i in uniquebattle:
                i.normalize()
            
            battleorder()
            
            x(introduction)
            if finalboss:
                renpy.call_in_new_context("bossspeech")
            
            while True:
                for i in currentbattle:
                    if i.stopped:
                        i.stopped -= 1
                    else:
                        for j in currentbattle:
                            if not j.friendly and j.health <= 0:
                                uniquebattle.remove(j)
                                currentbattle.remove(j)
                        
                        if not party[0].health and not party[1].health and not party[2].health:
                            if finalboss and not enemies[0].partywiped:
                                renpy.call_in_new_context("partywipe")
                                enemies[0].partywiped = True
                            else:
                                renpy.call_in_new_context("gameover")
                        
                        if i.friendly:
                            if len(uniquebattle) is len(party):
                                victory()
                                _game_menu_screen = "save_screen"
                                return
                            
                            if i.health:
                                while showmenu(i):
                                    pass
                        else:
                            i.act()
        
        def choose_class(classlist, index):
            if index == 0:
                ypos = 0.5
                xpos = 0.35
            elif index == 1:
                ypos = 0.5
                xpos = 0.7
            elif index == 2:
                ypos = 0.7
                xpos = 0.35
            
            ui.window(xfill=False, xpos=xpos, ypos=ypos, yminimum=0)
            ui.vbox()
            ui.text(classlist[0].name)
            ui.hbox()
            ui.add(classlist[classindex[index]].sprite.image())
            ui.vbox()
            for i in classlist:
                if party[index] and classindex[index] is not classlist.index(i):
                    clicked = None
                else:
                    clicked = ui.returns((True, index, classlist.index(i)))
                
                ui.textbutton(i.classname, hovered=ui.returns((False, index, classlist.index(i))), clicked=clicked)
            ui.close()
            ui.close()
            ui.close()
        
        def abs(a):
            if a < 0:
                return -a
            else:
                return a
        
        def showcredit(role, name, url=""):
            ui.window(xfill=False, xpos=0.5, ypos=0.5, yminimum=0)
            ui.hbox()
            ui.text(role, minwidth=250)
            ui.vbox()
            ui.text(name, minwidth=250)
            ui.text(url, minwidth=250)
            ui.close()
            ui.close()
            ui.timer(7.0, ui.returns(0))
            
            ui.interact()
        
        config.overlay_functions.append(battle_overlay)
        
        x = Character("")
        name_only = Character("", show_two_window=True)
        mira = Character("Mira", show_two_window=True)
        sylvia = Character("Sylvia", show_two_window=True)
        saber = Character("Saber", show_two_window=True)
        
        mira_f = BattleCharacter("Mira", True, "mira-knight.png")
        sylvia_f = Witch("Sylvia", True, "sylvia-healer.png")
        saber_f = Rogue("Saber", True, "saber-knight.png")
        
        mira_class = [ Knight("Mira", True, "mira-knight.png"), Ranger("Mira", True, "mira-ranger.png"), Witch("Mira", True, "mira-witch.png") ]
        sylvia_class = [ Healer("Sylvia", True, "sylvia-healer.png"), Rogue("Sylvia", True, "sylvia-rogue.png"), Witch("Sylvia", True, "sylvia-witch.png") ]
        saber_class = [ Knight("Saber", True, "saber-knight.png"), Ranger("Saber", True, "saber-ranger.png"), Rogue("Saber", True, "saber-rogue.png") ]
        
        for i in sylvia_class:
            i.sprite.ypos += 60
        
        for i in saber_class:
            i.sprite.ypos += 120
        
        classindex = [ 0, 0, 0 ]
        allitems = [ Potion(), Redboots(), Fullpotion(), Orcishtoken(), Grindstone(), Wizardfeather(), Wizarddust(), Leatherpadding() ]
        partyitems = [ Wizarddust(), Potion(), Potion(), Fullpotion(), Leatherpadding(), Grindstone() ]
        partygold = 0
        
        maplisting = [ (680, 190), (560, 210), (550, 190), (480, 200), (455, 250), (455, 260), (400, 260), (380, 210), (320, 210), (260, 240), (160, 240), (160, 240), (120, 200) ]
        mappos = 0
        
        for i in mira_class:
            i.hit = "%x slash at %y and take%s a nasty cut!"
            i.miss = "%x swing%s at %y, but fail%s to hit..."
            
            i.items = partyitems
        for i in sylvia_class:
            i.hit = "%x take%s a shot at %y, and it rings true, hitting hard."
            i.miss = "%x shoot%s at %y, but it narrowly misses..."
            
            i.items = partyitems
        for i in saber_class:
            i.hit = "%x land%s a mighty stab on %y!"
            i.miss = "%x thrust%s his blade, but %y knocks it away!"
            
            i.items = partyitems
        
        sylvia_class[0].spells = [ Cure(), Cure(), Cure(), Haste(), Majorheal(), Majorheal(), Protect(), Protect() ] 
        sylvia_class[2].spells = [ Spark(), Spark(), Spark(), Spark(), Lightning(), Paralyze(), Blizzard(), Blizzard() ]
        mira_class[2].spells = [ Paralyze(), Paralyze(), Slow(), Superheat(), Superheat() ]
        
        party = [ None, None, None ]
        currentbattle = uniquebattle = [ ]
        finalboss = False
    
    image bg forest day = "forest-day.png"
    image bg forest evening = "forest-evening.png"
    image bg river = "riverside.png"
    image bg battlefield = "battlefield.png"
    image bg battlefield evening = "battlefield-evening.png"
    image bg battlefield gray = "battlefield-gray.png"
    image bg battlefield darkness = "battlefield-darkness.png"
    image bg black = "black.png"
    image bg map = "map.png"
    image bg on the road = "ontheroad.png"
    image bg forest camp = "forest-camp.png"
    image bg camp = "camp.png"
    image bg dark woods = "dark-woods.png"
    image bg forest camp dark = "forest-camp-dark.png"
    image bg by a tree = "byatree.png"
    image bg sunset plains = "sunset-plains.png"
    image bg ruined town = "ruined-town.png"
    image bg ruined town day = "ruined-town-day.png"